


Screen 20,32,,64
Type bitmap_size
    As Single across,down
End Type

Type box
    As Single x,y
    As Single wide,high
    As Integer index,tally
    As Any Pointer im
End Type

Type bar
    As Integer x,y,l,d,percent
    As Uinteger col
End Type


'declarations
Declare Sub sound Alias "Beep"(f As Integer,d As Integer)  
Declare Function size(bmp As String) As bitmap_size 
Declare Sub LOAD_ARRAY(bmp As String,pixels() As Uinteger)
Declare Function inbox(p1() As box,p As box,i As Integer) As Integer
Declare Sub DRAW_PICTURE(mx As Integer=0,my As Integer=0,mybitmap As bitmap_size,scale As Single=1,c() As Uinteger,im As Any Pointer=0)
Declare Sub GET_PICTURE
Declare Sub SPLIT_PICTURE_IMAGE(mybitmap As bitmap_size,scale As Double=1)
Declare Sub ALLOCATE_FOR_IMAGES
Declare Sub update
Declare Sub mouse
Declare Sub moveboxes(flag As String="")
Declare Sub shuffle(flag As Integer=0)
Declare Sub setbackground
Declare Sub start
Declare Sub framecounter
Declare Sub main_loop
Declare Sub progressbar(b As bar)
Declare Sub setup
Declare Sub notes

'macros
#macro incircle(cx,cy,radius,x,y)
(cx-x)*(cx-x) +(cy-y)*(cy-y)<= radius*radius
#endmacro
#define progress(value,lower,upper) 100*(value-lower)/(upper-lower)

'variables
Dim Shared mybitmap As String
Dim Shared As Integer numsides,n
Redim Shared As Uinteger pixel_colours(0,0)
Redim Shared As Uinteger temps(0,0)
Dim Shared As Integer mix,cheatflag
Dim Shared As Any Pointer Small_image,blank,background
Dim Shared As String first
Dim Shared As String history
Redim Shared As box boxes(),switch()
Dim Shared As Integer percentage,_COUNT
Dim Shared As bar b'progress bar
b=Type<bar>(100,700,600,20,0,Rgb(200,0,0))

'==========================    RUN      ===============================
setup
start
shuffle
notes
main_loop
'======================================================================

Sub setup
    Paint(0,0),Rgb(0,0,100)
    GET_PICTURE                                     'from choices
    Redim  boxes( numsides^2)                       'Picture is held in boxes
    ALLOCATE_FOR_IMAGES                             'imagecreate all
    Paint blank,(0,0),Rgb(255,0,255)
    DRAW_PICTURE(0,0,size(mybitmap),.2,pixel_colours(),Small_image)'(small picture on right)
    SPLIT_PICTURE_IMAGE(size(mybitmap))             'Put bitmap in boxes
    setbackground
    Swap boxes(numsides^2).im,blank
    Color,Rgb(0,0,100)
    Randomize
End Sub
Sub notes
    For z As Integer=500 To 800 Step 50
        sound(z,60)
    Next z 
End Sub
Sub cheat
    #macro delay()
    For p As Double=1 To 20000000:Next
        #endmacro
        Static As Integer runflag
        If runflag=0 Then
            runflag=1
            For z As Integer=Ubound(switch) To 1 Step -1
                Swap boxes(switch(z).x).im,boxes(switch(z).y).im
                Swap boxes(switch(z).x).index,boxes(switch(z).y).index
                Swap boxes(switch(z).x).tally,boxes(switch(z).y).tally
                Screenlock
                Cls
                update
                Screenunlock
                ''delay()'optional
            Next z
        End If
    End Sub
    
    Sub main_loop
        Dim As String i
        Dim As Integer mx,my,mb
        Dim As box ms
        Do
            framecounter
            Getmouse(mx,my,,mb)
            ms.x=mx
            ms.y=my
            i=Inkey
            moveboxes()
            Screenlock
            Cls
            update
            Draw String(350,655),"Move a square into the space by mouse click",Rgb(0,0,200)
            If inbox(boxes(0),ms,0) Then
                cheatflag=1
                If mb=1 Then
                    Screenunlock
                    cheat
                End If
            Else
                cheatflag=0
            End If
            Screenunlock
            
            If history=first Then
                Swap boxes(numsides^2).im,blank
                Screenunlock
                Exit Do
            End If
            Sleep 1,1
        Loop Until i=Chr(27)
        If history<>first Then Goto finish
        Put(0,0),background
        update
        notes
        Put(400,650),boxes(0).im,Pset
        Draw String(400,660),"DONE-Any key",Rgb(0,0,0)
        Sleep
        finish:
        imagedestroy Small_image
        imagedestroy blank
        imagedestroy background
        For z As Integer=0 To Ubound(boxes)
            imagedestroy boxes(z).im
        Next z
    End Sub
    
    Sub progressbar(b As bar)
        Line(b.x+1,b.y+1)-( (b.l*b.percent/100+b.x),b.y+b.d-1),b.col,bf
        Line(b.x,b.y)-(b.x+b.l,b.y+b.d),,b
    End Sub
    
    
    Sub setbackground
        Bload "media/background.bmp",background
        Put background,( 850, 20),Small_image,Pset 'guide picture
        For k As Integer=-10 To 0 'frames
            Line background,(850-k/5,20-k/5)-(850+.2*800+k/5,20+.2*600+k/5),Rgb(200,250+20*k,0),b   
            Line background,(10-k,10-k)-(830+k,630+k),Rgb(200,250+20*k,0),b
        Next k
    End Sub
    
    Sub GET_PICTURE
        Dim As Integer mx,my,mb,flag,bflag,cflag,c1,c2,c3
        Dim As box ms
        Dim As Integer accum
        Dim As box thumbs(1 To 5)
        Dim As String s
        Dim As Any Pointer im(1 To 5)
        For z As Integer=0 To 4
            accum=accum+10
            With thumbs(z+1)
                .x=.2*800*z+accum+60
                .wide=.2*800
                .high=.2*600
                .y=100
            End With
        Next z
        For z As Integer=1 To 5
            thumbs(z).im=imagecreate(.2*800,.2*600)
        Next z
        
        For z As Integer=1 To 5
            Select Case z
            Case 1
                s="media/one.bmp"
                LOAD_ARRAY s,temps()
                DRAW_PICTURE(thumbs(z).x,thumbs(z).y,size(s),.2,temps())
                DRAW_PICTURE(0,0,size(s),.2,temps(),thumbs(z).im)
            Case 2
                s="media/two.bmp"
                LOAD_ARRAY s,temps()
                DRAW_PICTURE(thumbs(z).x,thumbs(z).y,size(s),.2,temps())
                DRAW_PICTURE(0,0,size(s),.2,temps(),thumbs(z).im)
            Case 3
                s="media/three.bmp"
                LOAD_ARRAY s,temps()
                DRAW_PICTURE(thumbs(z).x,thumbs(z).y,size(s),.2,temps())
                DRAW_PICTURE(0,0,size(s),.2,temps(),thumbs(z).im)
            Case 4
                s="media/four.bmp"
                LOAD_ARRAY s,temps()
                DRAW_PICTURE(thumbs(z).x,thumbs(z).y,size(s),.2,temps())
                DRAW_PICTURE(0,0,size(s),.2,temps(),thumbs(z).im)
            Case 5
                s="media/five.bmp"
                LOAD_ARRAY s,temps()
                DRAW_PICTURE(thumbs(z).x,thumbs(z).y,size(s),.2,temps())
                DRAW_PICTURE(0,0,size(s),.2,temps(),thumbs(z).im)
            End Select
        Next z
        Do
            Screenlock
            Cls
            Paint(0,0),Rgb(0,0,100)
            Getmouse mx,my,,mb
            ms.x=mx:ms.y=my    
            For z As Integer=1 To 5
                Put (thumbs(z).x,thumbs(z).y),thumbs(z).im,Pset
            Next z
            For z As Integer=1 To 5
                If inbox(thumbs(),ms,z) Then
                    Line(thumbs(z).x,thumbs(z).y)-(thumbs(z).x+thumbs(z).wide,thumbs(z).y+thumbs(z).high),Rgba(200,200,200,60),BF
                    Line(thumbs(z).x,thumbs(z).y)-(thumbs(z).x+thumbs(z).wide,thumbs(z).y+thumbs(z).high),Rgb(255,0,0),B
                    
                    If mb=1 Then
                        flag=z
                        bflag=1
                    End If
                End If
            Next z
            
            If flag Then 'keep frame
                Line(thumbs(flag).x,thumbs(flag).y)-(thumbs(flag).x+thumbs(flag).wide,thumbs(flag).y+thumbs(flag).high),Rgba(200,200,200,60),BF
                Line(thumbs(flag).x,thumbs(flag).y)-(thumbs(flag).x+thumbs(flag).wide,thumbs(flag).y+thumbs(flag).high),Rgb(255,0,0),B
            End If
         draw string(300,250),"Click a picture and a choice",rgb(255,255,255)   
            Circle(thumbs(2).x,thumbs(2).y+300),50,Rgb(0,100,0),,,,f
            Draw String(thumbs(2).x-20,thumbs(2).y+295),"EIGHTS"
            If incircle(thumbs(2).x,(thumbs(2).y+300),50,mx,my) Then
                Circle(thumbs(2).x,thumbs(2).y+300),52,Rgb(200,200,200)
                If mb=1 Then: cflag=1:c1=1:c2=0:c3=0:numsides=3:End If
            End If
            If c1=1 Then Circle(thumbs(2).x,thumbs(2).y+300),52,Rgb(200,200,200)
            Circle(thumbs(3).x,thumbs(2).y+300),50,Rgb(0,100,0),,,,f
            Draw String(thumbs(3).x-30,thumbs(2).y+295),"FIFTEENS"
            If incircle(thumbs(3).x,(thumbs(2).y+300),50,mx,my) Then
                Circle(thumbs(3).x,thumbs(2).y+300),52,Rgb(200,200,200)
                If mb=1 Then: cflag=1:c1=0:c2=1:c3=0:numsides=4:End If
            End If
            If c2=1 Then Circle(thumbs(3).x,thumbs(2).y+300),52,Rgb(200,200,200)
            Circle(thumbs(4).x,thumbs(2).y+300),50,Rgb(0,100,0),,,,f
            Draw String(thumbs(4).x-40,thumbs(2).y+295),"TWENTYFOURS"
            If incircle(thumbs(4).x,(thumbs(2).y+300),50,mx,my) Then
                Circle(thumbs(4).x,thumbs(2).y+300),52,Rgb(200,200,200)
                If mb=1 Then: cflag=1:c1=0:c2=0:c3=1:numsides=5:End If
            End If
            If c3=1 Then Circle(thumbs(4).x,thumbs(2).y+300),52,Rgb(200,200,200)
            
            If bflag=1 And cflag=1 Then 'load
                Circle(thumbs(5).x,thumbs(2).y+300),50,Rgb(0,100,0),,,,f
                Draw String(thumbs(5).x-20,thumbs(2).y+300),"LOAD"
                If incircle(thumbs(5).x,(thumbs(2).y+300),50,mx,my) Then
                    Circle(thumbs(5).x,thumbs(2).y+300),52,Rgb(200,200,200)
                    If mb=1 Then
                        Screenunlock
                        Exit Do 
                    End If
                End If
            End If
            Screenunlock
            Sleep 1,1
        Loop
        Cls
        Select Case flag
        Case 1
            mybitmap="media/one.bmp"
            LOAD_ARRAY mybitmap,pixel_colours()
        Case 2
            mybitmap="media/two.bmp"
            LOAD_ARRAY mybitmap,pixel_colours()   
        Case 3
            mybitmap="media/three.bmp"
            LOAD_ARRAY mybitmap,pixel_colours()
        Case 4
            mybitmap="media/four.bmp"
            LOAD_ARRAY mybitmap,pixel_colours()
        Case 5
            mybitmap="media/five.bmp"
            LOAD_ARRAY mybitmap,pixel_colours()
        End Select
        
        For z As Integer=1 To 5
            imagedestroy thumbs(z).im
        Next z
        n=numsides-1
    End Sub
    
    
    Function inbox(p1() As box,p As box,i As Integer) As Integer
        Return (p.x>p1(i).x)*(p.x<(p1(i).x+p1(i).wide))*(p.y>p1(i).y)*(p.y<(p1(i).y+p1(i).high))
    End Function
    
    Function size(bmp As String) As bitmap_size 
        Dim As Integer w,h
        Open bmp For Binary As #1
        Get #1, 19, w
        Get #1, 23, h
        Close #1
        Return Type<bitmap_size>(w,h)
    End Function
    
    Sub LOAD_ARRAY(bmp As String,pixels() As Uinteger) 
        Dim As Integer xr,yr
        Screeninfo xr,yr
        Dim As Any Pointer tempimage=imagecreate(xr,yr)
        Bload bmp,tempimage
        Dim temp As bitmap_size=size(bmp)
        Redim pixels(temp.across,temp.down)
        For x As Integer=0 To temp.across
            For y As Integer=0 To temp.down
                pixels(x,y)=Point(x,y,tempimage) 
            Next y
        Next x
        imagedestroy tempimage
    End Sub
    
    Sub DRAW_PICTURE(mx As Integer=0,my As Integer=0,mybitmap As bitmap_size,scale As Single=1,c() As Uinteger,im As Any Pointer=0)
        #macro magnify(pivotx,pivoty,px,py,scale)
        var rotx=scale*(px-pivotx)+pivotx
        var roty=scale*(py-pivoty)+pivoty
        #endmacro
        For x As Integer=mx To mx+mybitmap.across
            For y As Integer=my To my+mybitmap.down
                magnify(mx,my,x,y,scale)
                Pset im,(rotx,roty),c(x-mx,y-my)
            Next y
        Next x
        
    End Sub
    
    Sub framecounter
        Static As Double frame,fps
        frame=frame+1
        Static As Double t1,t2
        If frame>=fps Then
            t1 = Timer
            fps = frame/(t1-t2)
            Windowtitle "Frames per second = " & fps
            t2=Timer
            frame=0
        End If
    End Sub
    
    Sub ALLOCATE_FOR_IMAGES
        Dim As Integer xres,yres
        Screeninfo xres,yres
        background=imagecreate (xres,yres)
        Small_image=imagecreate(.2*Ubound(pixel_colours,1),.2*Ubound(pixel_colours,2))
        For z As Integer=1 To Ubound(boxes)
            boxes(z).im=imagecreate(Ubound(pixel_colours,1)/numsides,Ubound(pixel_colours,2)/numsides)
        Next z
        boxes(0).im=imagecreate(100,50,Rgb(0,100,0))
        blank=imagecreate(Ubound(pixel_colours,1)/numsides,Ubound(pixel_colours,2)/numsides)
    End Sub
    
    Sub SPLIT_PICTURE_IMAGE(mybitmap As bitmap_size,scale As Double=1)
        Dim As Integer count
        Dim As String temp
        For r As Integer=0 To n
            var mx=r*mybitmap.across/(n+1)
            For c As Integer=0 To n
                count=count+1
                temp=Str(count)
                first=first+temp
                var  my=c*mybitmap.down/(n+1)
                With boxes(count)
                    .x=scale*mx
                    .y=scale*my
                    .index=count
                    .tally=count
                    .wide=mybitmap.across/numsides
                    .high=mybitmap.down/numsides
                End With
                For x As Double=mx To mx+mybitmap.across/numsides
                    For y As Double=my To my+mybitmap.down/numsides
                        Dim As Double xx=x-mx 
                        Dim As Double yy=y-my
                        If x<Ubound(pixel_colours,1) And y<Ubound(pixel_colours,2) Then
                            Pset boxes(count).im,(xx,yy),pixel_colours(x,y)
                        End If
                    Next y
                Next x
            Next c
        Next r
        boxes(0).x=20:boxes(0).y=650:boxes(0).wide=100:boxes(0).high=50
    End Sub
    
    Sub update
        Put(0,0),background,Pset
        Dim temp As String
        var h=""
        For z As Integer=1 To Ubound(boxes)
            Put (boxes(z).x+20,boxes(z).y+20),boxes(z).im,trans
            temp=Str(boxes(z).tally)
            h=h+temp
        Next z
        history=h
        If _count<10*numsides^2 Then
            percentage=progress(_COUNT,1,10*numsides^2)
            b.percent=percentage
            progressbar(b)
        End If
        If _count>=10*numsides^2 Then
            Put(20,650),boxes(0).im,Pset
            If cheatflag Then Line(20,650)-(120,700),Rgba(255,0,0,150),bf
            Draw String(25,660),"Finish off",Rgb(0,0,0)
        End If
    End Sub
    
    Sub shuffle(flag As Integer=0)
        If flag=1 Then Exit Sub
        Do
            moveboxes("shuffle")
            Screenlock
            Cls
            update
            If mix =1 Then Screenunlock:Exit Sub
            Screenunlock
            Sleep 1,1
        Loop
    End Sub
    
    Sub moveboxes(flag As String="")
        Dim As Integer mx,my,mb,soundflag
        Dim As box mp
        Static As Integer flag2
        ''Randomize
        If Len(flag)=0 Then
            soundflag=1
            Getmouse mx,my,,mb
        Else
            mx=Rnd*800
            my=Rnd*600
            mb=1
            flag2=0
            If _COUNT>numsides*numsides*10 Then mix=1: Exit Sub  
        End If
        mp.x=mx
        mp.y=my
        Dim As Integer tot=numsides*numsides
        If mb=0 Then flag2=0
        For z1 As Integer=1 To tot
            If inbox(boxes(),mp,z1) And mb=1 Then
                If flag2=0 And soundflag=1 Then sound(900,1) 
                '_______________________
                If z1+1<=tot Then
                    
                    If boxes(z1+1).index=tot Then
                        If z1 Mod numsides<>0 Then
                            _COUNT=_COUNT+1
                            If flag2=0 Then Redim Preserve switch(Ubound(switch)+1)
                            flag2=1
                            switch(Ubound(switch)).x=z1
                            switch(Ubound(switch)).y=z1+1
                            Swap boxes(z1).im,boxes(z1+1).im
                            Swap boxes(z1).index,boxes(z1+1).index
                            Swap boxes(z1).tally,boxes(z1+1).tally
                            Exit For
                        End If
                    End If
                End If
                '______________________________________
                If z1-1>=1 Then
                    If boxes(z1-1).index=tot Then
                        _COUNT=_COUNT+1
                        If flag2=0 Then Redim Preserve switch(Ubound(switch)+1)
                        flag2=1
                        switch(Ubound(switch)).x=z1
                        switch(Ubound(switch)).y=z1-1
                        Swap boxes(z1).im,boxes(z1-1).im
                        Swap boxes(z1).index,boxes(z1-1).index
                        Swap boxes(z1).tally,boxes(z1-1).tally
                        Exit For
                    End If
                End If
                '_____________________________________
                If z1+numsides<=tot Then
                    If boxes(z1+numsides).index=tot Then
                        _COUNT=_COUNT+1
                        If flag2=0 Then Redim Preserve switch(Ubound(switch)+1)
                        flag2=1
                        switch(Ubound(switch)).x=z1
                        switch(Ubound(switch)).y=z1+numsides
                        Swap boxes(z1).im,boxes(z1+numsides).im
                        Swap boxes(z1).index,boxes(z1+numsides).index
                        Swap boxes(z1).tally,boxes(z1+numsides).tally
                        Exit For
                    End If
                End If 
                '___________________________________________
                If z1-numsides>=1  Then
                    If boxes(z1-numsides).index=tot Then
                        _COUNT=_COUNT+1
                        If flag2=0 Then Redim Preserve switch(Ubound(switch)+1)
                        flag2=1
                        switch(Ubound(switch)).x=z1
                        switch(Ubound(switch)).y=z1-numsides
                        Swap boxes(z1).im,boxes(z1-numsides).im
                        Swap boxes(z1).index,boxes(z1-numsides).index
                        Swap boxes(z1).tally,boxes(z1-numsides).tally
                        Exit For
                    End If
                End If
            End If'inbox
        Next z1
    End Sub
    
    Sub start
        Dim As Integer mx,my,mb,flag
        Dim As box ms
        Do
            Getmouse mx,my,,mb
            If incircle(500,700,50,mx,my) Then 
                flag=1
                If mb=1 Then Exit Sub
            End If
            ms.x=mx:ms.y=my
            Screenlock
            Cls
            Put(0,0),background,Pset
            Circle(500,700),50,Rgb(100,50,0),,,,f
            Draw String(470,700),"SHUFFLE",Rgb(0,0,0)
            If flag=1 Then 
                Circle(500,700),52,Rgb(0,0,0)
                flag=0
            End If
            DRAW_PICTURE(20,20,size(mybitmap),1,pixel_colours())
            DRAW_PICTURE( 850, 20,size(mybitmap),.2,pixel_colours())
            Screenunlock
            Sleep 1,1
        Loop Until Len(Inkey)
    End Sub
    